// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"go.phucam.tv/ent/portal"
	"go.phucam.tv/ent/portalmetadata"
	"go.phucam.tv/ent/predicate"
)

// PortalMetadataQuery is the builder for querying PortalMetadata entities.
type PortalMetadataQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.PortalMetadata
	// eager-loading edges.
	withPortal *PortalQuery
	withFKs    bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the PortalMetadataQuery builder.
func (pmq *PortalMetadataQuery) Where(ps ...predicate.PortalMetadata) *PortalMetadataQuery {
	pmq.predicates = append(pmq.predicates, ps...)
	return pmq
}

// Limit adds a limit step to the query.
func (pmq *PortalMetadataQuery) Limit(limit int) *PortalMetadataQuery {
	pmq.limit = &limit
	return pmq
}

// Offset adds an offset step to the query.
func (pmq *PortalMetadataQuery) Offset(offset int) *PortalMetadataQuery {
	pmq.offset = &offset
	return pmq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (pmq *PortalMetadataQuery) Unique(unique bool) *PortalMetadataQuery {
	pmq.unique = &unique
	return pmq
}

// Order adds an order step to the query.
func (pmq *PortalMetadataQuery) Order(o ...OrderFunc) *PortalMetadataQuery {
	pmq.order = append(pmq.order, o...)
	return pmq
}

// QueryPortal chains the current query on the "portal" edge.
func (pmq *PortalMetadataQuery) QueryPortal() *PortalQuery {
	query := &PortalQuery{config: pmq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := pmq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := pmq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(portalmetadata.Table, portalmetadata.FieldID, selector),
			sqlgraph.To(portal.Table, portal.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, portalmetadata.PortalTable, portalmetadata.PortalColumn),
		)
		fromU = sqlgraph.SetNeighbors(pmq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first PortalMetadata entity from the query.
// Returns a *NotFoundError when no PortalMetadata was found.
func (pmq *PortalMetadataQuery) First(ctx context.Context) (*PortalMetadata, error) {
	nodes, err := pmq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{portalmetadata.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (pmq *PortalMetadataQuery) FirstX(ctx context.Context) *PortalMetadata {
	node, err := pmq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first PortalMetadata ID from the query.
// Returns a *NotFoundError when no PortalMetadata ID was found.
func (pmq *PortalMetadataQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = pmq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{portalmetadata.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (pmq *PortalMetadataQuery) FirstIDX(ctx context.Context) int {
	id, err := pmq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single PortalMetadata entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one PortalMetadata entity is found.
// Returns a *NotFoundError when no PortalMetadata entities are found.
func (pmq *PortalMetadataQuery) Only(ctx context.Context) (*PortalMetadata, error) {
	nodes, err := pmq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{portalmetadata.Label}
	default:
		return nil, &NotSingularError{portalmetadata.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (pmq *PortalMetadataQuery) OnlyX(ctx context.Context) *PortalMetadata {
	node, err := pmq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only PortalMetadata ID in the query.
// Returns a *NotSingularError when more than one PortalMetadata ID is found.
// Returns a *NotFoundError when no entities are found.
func (pmq *PortalMetadataQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = pmq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{portalmetadata.Label}
	default:
		err = &NotSingularError{portalmetadata.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (pmq *PortalMetadataQuery) OnlyIDX(ctx context.Context) int {
	id, err := pmq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of PortalMetadataSlice.
func (pmq *PortalMetadataQuery) All(ctx context.Context) ([]*PortalMetadata, error) {
	if err := pmq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return pmq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (pmq *PortalMetadataQuery) AllX(ctx context.Context) []*PortalMetadata {
	nodes, err := pmq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of PortalMetadata IDs.
func (pmq *PortalMetadataQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := pmq.Select(portalmetadata.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (pmq *PortalMetadataQuery) IDsX(ctx context.Context) []int {
	ids, err := pmq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (pmq *PortalMetadataQuery) Count(ctx context.Context) (int, error) {
	if err := pmq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return pmq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (pmq *PortalMetadataQuery) CountX(ctx context.Context) int {
	count, err := pmq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (pmq *PortalMetadataQuery) Exist(ctx context.Context) (bool, error) {
	if err := pmq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return pmq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (pmq *PortalMetadataQuery) ExistX(ctx context.Context) bool {
	exist, err := pmq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the PortalMetadataQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (pmq *PortalMetadataQuery) Clone() *PortalMetadataQuery {
	if pmq == nil {
		return nil
	}
	return &PortalMetadataQuery{
		config:     pmq.config,
		limit:      pmq.limit,
		offset:     pmq.offset,
		order:      append([]OrderFunc{}, pmq.order...),
		predicates: append([]predicate.PortalMetadata{}, pmq.predicates...),
		withPortal: pmq.withPortal.Clone(),
		// clone intermediate query.
		sql:    pmq.sql.Clone(),
		path:   pmq.path,
		unique: pmq.unique,
	}
}

// WithPortal tells the query-builder to eager-load the nodes that are connected to
// the "portal" edge. The optional arguments are used to configure the query builder of the edge.
func (pmq *PortalMetadataQuery) WithPortal(opts ...func(*PortalQuery)) *PortalMetadataQuery {
	query := &PortalQuery{config: pmq.config}
	for _, opt := range opts {
		opt(query)
	}
	pmq.withPortal = query
	return pmq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"createdAt,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.PortalMetadata.Query().
//		GroupBy(portalmetadata.FieldCreatedAt).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (pmq *PortalMetadataQuery) GroupBy(field string, fields ...string) *PortalMetadataGroupBy {
	grbuild := &PortalMetadataGroupBy{config: pmq.config}
	grbuild.fields = append([]string{field}, fields...)
	grbuild.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := pmq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return pmq.sqlQuery(ctx), nil
	}
	grbuild.label = portalmetadata.Label
	grbuild.flds, grbuild.scan = &grbuild.fields, grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		CreatedAt time.Time `json:"createdAt,omitempty"`
//	}
//
//	client.PortalMetadata.Query().
//		Select(portalmetadata.FieldCreatedAt).
//		Scan(ctx, &v)
//
func (pmq *PortalMetadataQuery) Select(fields ...string) *PortalMetadataSelect {
	pmq.fields = append(pmq.fields, fields...)
	selbuild := &PortalMetadataSelect{PortalMetadataQuery: pmq}
	selbuild.label = portalmetadata.Label
	selbuild.flds, selbuild.scan = &pmq.fields, selbuild.Scan
	return selbuild
}

func (pmq *PortalMetadataQuery) prepareQuery(ctx context.Context) error {
	for _, f := range pmq.fields {
		if !portalmetadata.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if pmq.path != nil {
		prev, err := pmq.path(ctx)
		if err != nil {
			return err
		}
		pmq.sql = prev
	}
	return nil
}

func (pmq *PortalMetadataQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*PortalMetadata, error) {
	var (
		nodes       = []*PortalMetadata{}
		withFKs     = pmq.withFKs
		_spec       = pmq.querySpec()
		loadedTypes = [1]bool{
			pmq.withPortal != nil,
		}
	)
	if pmq.withPortal != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, portalmetadata.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		return (*PortalMetadata).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		node := &PortalMetadata{config: pmq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, pmq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := pmq.withPortal; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*PortalMetadata)
		for i := range nodes {
			if nodes[i].portal_metadata == nil {
				continue
			}
			fk := *nodes[i].portal_metadata
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(portal.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "portal_metadata" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Portal = n
			}
		}
	}

	return nodes, nil
}

func (pmq *PortalMetadataQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := pmq.querySpec()
	_spec.Node.Columns = pmq.fields
	if len(pmq.fields) > 0 {
		_spec.Unique = pmq.unique != nil && *pmq.unique
	}
	return sqlgraph.CountNodes(ctx, pmq.driver, _spec)
}

func (pmq *PortalMetadataQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := pmq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (pmq *PortalMetadataQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   portalmetadata.Table,
			Columns: portalmetadata.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: portalmetadata.FieldID,
			},
		},
		From:   pmq.sql,
		Unique: true,
	}
	if unique := pmq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := pmq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, portalmetadata.FieldID)
		for i := range fields {
			if fields[i] != portalmetadata.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := pmq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := pmq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := pmq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := pmq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (pmq *PortalMetadataQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(pmq.driver.Dialect())
	t1 := builder.Table(portalmetadata.Table)
	columns := pmq.fields
	if len(columns) == 0 {
		columns = portalmetadata.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if pmq.sql != nil {
		selector = pmq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if pmq.unique != nil && *pmq.unique {
		selector.Distinct()
	}
	for _, p := range pmq.predicates {
		p(selector)
	}
	for _, p := range pmq.order {
		p(selector)
	}
	if offset := pmq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := pmq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// PortalMetadataGroupBy is the group-by builder for PortalMetadata entities.
type PortalMetadataGroupBy struct {
	config
	selector
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (pmgb *PortalMetadataGroupBy) Aggregate(fns ...AggregateFunc) *PortalMetadataGroupBy {
	pmgb.fns = append(pmgb.fns, fns...)
	return pmgb
}

// Scan applies the group-by query and scans the result into the given value.
func (pmgb *PortalMetadataGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := pmgb.path(ctx)
	if err != nil {
		return err
	}
	pmgb.sql = query
	return pmgb.sqlScan(ctx, v)
}

func (pmgb *PortalMetadataGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range pmgb.fields {
		if !portalmetadata.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := pmgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := pmgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (pmgb *PortalMetadataGroupBy) sqlQuery() *sql.Selector {
	selector := pmgb.sql.Select()
	aggregation := make([]string, 0, len(pmgb.fns))
	for _, fn := range pmgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(pmgb.fields)+len(pmgb.fns))
		for _, f := range pmgb.fields {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(pmgb.fields...)...)
}

// PortalMetadataSelect is the builder for selecting fields of PortalMetadata entities.
type PortalMetadataSelect struct {
	*PortalMetadataQuery
	selector
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (pms *PortalMetadataSelect) Scan(ctx context.Context, v interface{}) error {
	if err := pms.prepareQuery(ctx); err != nil {
		return err
	}
	pms.sql = pms.PortalMetadataQuery.sqlQuery(ctx)
	return pms.sqlScan(ctx, v)
}

func (pms *PortalMetadataSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := pms.sql.Query()
	if err := pms.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
